<?php 

class controller_component_questions extends component {

	function action_index() {

		$this->page['title'] = 'Вопросы и ответы';

		$this->page['keywords'] = 'Вопросы, ответы, вопрос на `засыпку`';

		$this->page['description'] = 'Задайте вопрос на любую тему и получите ответ';

		$this->page['head'] = $this->add_css_file(SITE_URL . '/modules/components/' . $this->component_name . '/back_end/views/style.css');

		$this->data['count'] = $this->model->get_count();

		$this->data['post_on_page'] = 3;

		$this->data['pages_count'] = intval(($this->data['count'] - 1) / $this->data['post_on_page'] + 1);

		$this->data['component_name'] = $this->component_name;

		$this->data['modul_name'] = $this->component_info['name'];

		$this->data['base_link'] = SITE_URL . '/admin/' . $this->component_name;

		if (isset($_GET['id_to_delete'])) {

			$this->data['control'] = $this->model->delete_question($_GET['id_to_delete']);

			$this->data['alert']  = 'Вопрос удален';

			/*Пересчитываем число страниц*/

			$this->data['count'] = $this->model->get_count();

			$this->data['pages_count'] = intval(($this->data['count'] - 1) / $this->data['post_on_page'] + 1);
		}

		else {

			$this->page['html'] = $this->load_view();
		}

		$this->data['page'] = (isset($_GET['page'])) ? $_GET['page'] : 1;

		if (isset($_POST['add_answer']) and !empty($_POST['text'])) {

			$this->model->into_answer($_POST['text'], $_POST['id']);

			$this->data['alert'] = 'Ответ добавлен';

			/*Пересчитываем число страниц*/

			$this->data['count'] = $this->model->get_count_without_answer();

			$this->data['pages_count'] = intval(($this->data['count'] - 1) / $this->data['post_on_page'] + 1);

			$this->data['page'] = 1;
		}

		else if (isset($_POST['add_answer']) and empty($_POST['text'])){

			unset($this->data['alert']);

			$this->data['alert_danger'] = '<span>' . 'Вы забыли дать ответ!' . '</span>';

			$this->page['html'] = $this->load_view('without_answer');
		}

		else {

			$this->data['page'] = (isset($_GET['page'])) ? $_GET['page'] : 1;
		}

		$this->data['question'] = $this->model->get_all($this->data['page'], $this->data['post_on_page']);

		foreach ($this->data['question'] as &$value) {
				
			$value['link'] = $this->data['base_link'] . "?id_to_delete=" . $value['id'];
		}

		$this->page['html'] = $this->load_view();

		return $this->page;					
	}

	function action_without_answer() {

		$this->page['title'] = 'Вопросы и ответы';

		$this->page['keywords'] = 'Вопросы, ответы, вопрос на `засыпку`';

		$this->page['description'] = 'Задайте вопрос на любую тему и получите ответ';

		$this->data['count'] = $this->model->get_count_without_answer();

		$this->data['post_on_page'] = 3;

		$this->data['pages_count'] = intval(($this->data['count'] - 1) / $this->data['post_on_page'] + 1);

		$this->page['head'] = $this->add_css_file(SITE_URL . '/modules/components/' . $this->component_name . '/back_end/views/style.css');

		$this->data['component_name'] = $this->component_name;

		$this->data['modul_name'] = $this->component_info['name'];

		$this->data['base_link'] = SITE_URL . '/admin/' . $this->data['component_name'];

		if (isset($_GET['id_to_delete'])) {

			$this->data['control'] = $this->model->delete_question($_GET['id_to_delete']);

			$this->data['alert'] = 'Вопрос удален';

			/*Пересчитываем число страниц*/

			$this->data['count'] = $this->model->get_count_without_answer();

			$this->data['pages_count'] = intval(($this->data['count'] - 1) / $this->data['post_on_page'] + 1);

			$_GET['page'] = 1;
		}

		else {

			$this->page['html'] = $this->load_view('without_answer');
		}

		$this->data['page'] = (isset($_GET['page'])) ? $_GET['page'] : 1;

		if (isset($_POST['add_answer']) and !empty($_POST['text'])) {

			$this->model->into_answer($_POST['text'], $_POST['id']);

			$this->data['alert'] = 'Ответ добавлен';

			/*Пересчитываем число страниц*/

			$this->data['count'] = $this->model->get_count_without_answer();

			$this->data['pages_count'] = intval(($this->data['count'] - 1) / $this->data['post_on_page'] + 1);

			$this->data['page'] = 1;

		}

		else if (isset($_POST['add_answer']) and empty($_POST['text'])){

			unset($this->data['alert']);

			$this->data['alert_danger'] = '<span>' . 'Вы забыли дать ответ!' . '</span>';

			$this->page['html'] = $this->load_view('without_answer');
		}

		else {

			$this->data['page'] = (isset($_GET['page'])) ? $_GET['page'] : 1;
		}

		$this->data['question'] = $this->model->get_without_answer($this->data['page'], $this->data['post_on_page']);

		foreach ($this->data['question'] as &$value) {
				
			$value['link'] = $this->data['base_link'] . '/without_answer' . "?id_to_delete=" . $value['id'];
		}

		$this->page['html'] = $this->load_view('without_answer');

		return $this->page;					
	}
} 						 